<a href="https://mp.weixin.qq.com/s/US5nTxbC2nYc1hWpn5Bozw" target="_blank">👉 **我整理汇总了 10 本优质的 Java 面试相关的 PDF（质量很高！不要再看网上的那些东拼西凑的垃圾面试题了！），点击下载，希望对需要的小伙伴有帮助**！</a>

<p align="center">
  <a href="https://tobebetterjavaer.com">
    <img src="http://cdn.tobebetterjavaer.com/tobebetterjavaer/images/logo-01.png" width="260px" alt="Java 程序员进阶之路">
  </a>
</p>

<p align="center">
  <a href="https://github.com/itwanger/toBeBetterJavaer" target="_blank"><img src="https://img.shields.io/badge/Github-toBeBetterJavaer-red.svg"></a>
  <a href="https://gitee.com/itwanger/toBeBetterJavaer" target="_blank"><img src="https://img.shields.io/badge/Gitee-toBeBetterJavaer-blue.svg"></a>
  <a href="https://space.bilibili.com/513340480" target="_blank"><img src="https://img.shields.io/badge/bilibili-哔哩哔哩-critical"></a>
  <a href="https://mp.weixin.qq.com/s/ExjM-xdqMFFY1NIZffz-Ng" target="_blank">
    <img src="https://img.shields.io/badge/计算机经典电子书-下载-green.svg" alt="无套路下载">
  </a>
</p>


# 为什么会有这个开源知识库

> [!NOTE]
> 知识库取名 **toBeBetterJavaer**，即 **To Be Better Javaer**，意为「成为一名更好的 Java 程序员」，是自学 Java 以来所有原创文章和学习资料的大聚合。内容包括 Java 基础、Java 并发编程、Java 虚拟机、Java 企业级开发、Java 面试等核心知识点。据说每一个优秀的 Java 程序员都喜欢她，风趣幽默、通俗易懂。学 Java，就认准 Java 程序员进阶之路😄。
>  
>  知识库旨在为学习 Java 的小伙伴提供一系列：
>  - **优质的原创 Java 教程**
>  - **全面清晰的 Java 学习路线**
>  - **免费但靠谱的 Java 学习资料**
>  - **精选的 Java 岗求职面试指南**
>  - **Java 企业级开发所需的必备技术**
>
> 赠人玫瑰手有余香。知识库会持续保持**更新**，欢迎收藏品鉴！
>
> **转载须知** ：以下所有文章如非文首说明为转载皆为我（沉默王二）的原创，转载在文首注明出处，如发现恶意抄袭/搬运，会动用法律武器维护自己的权益。让我们一起维护一个良好的技术创作环境！
> 
> 推荐你通过在线阅读网站进行阅读，体验更好，速度更快！
> 
> - [Java 程序员进阶之路在线阅读网站（VuePress 版）](https://tobebetterjavaer.com/)
> - [Java 程序员进阶之路在线阅读网站（docsify 版）](https://docsify.tobebetterjavaer.com/)
> 
> 建议给本仓库点个 star，满足一下我的虚荣心，内容质量也绝对值得你一个 star。我还在继续创作，给我一点继续更新的动力，笔芯。


# 知识库地图

> [!NOTE]
> 知识库收录的核心内容就全在这里面了，大类分为 Java 核心、Java 企业级开发、数据库、计算机基础、求职面试、学习资源、程序人生，几乎你需要的这里都有。

![](http://cdn.tobebetterjavaer.com/tobebetterjavaer/images/tobebetterjavaer-map.png)


# 学习路线

>[!NOTE]
> 除了 Java 学习路线，还有 C语言、C++、Python、Go 语言、操作系统、前端、蓝桥杯等硬核学习路线，欢迎收藏品鉴！

  * [Java学习路线一条龙版（建议收藏:+1:）](docs/xuexiluxian/java/yitiaolong.md)
  * [Java并发编程学习路线（建议收藏:+1:）](docs/xuexiluxian/java/thread.md)
  * [Java虚拟机学习路线（建议收藏:+1:）](docs/xuexiluxian/java/jvm.md)
  * [C语言学习路线（建议收藏:+1:）](docs/xuexiluxian/c.md)
  * [C++学习路线（建议收藏:+1:）](docs/xuexiluxian/ccc.md)
  * [Python学习路线（建议收藏:+1:）](docs/xuexiluxian/python.md)
  * [Go语言学习路线（建议收藏:+1:）](docs/xuexiluxian/go.md)
  * [操作系统学习路线（建议收藏:+1:）](docs/xuexiluxian/os.md)
  * [前端学习路线（建议收藏:+1:）](docs/xuexiluxian/qianduan.md)
  * [蓝桥杯学习路线（建议收藏:+1:）](docs/xuexiluxian/lanqiaobei.md)
  * [算法和数据结构学习路线（建议收藏:+1:）](docs/xuexiluxian/algorithm.md)

# Java核心

> [!NOTE]
>  **Java核心非常重要**！我将其分成了面渣逆袭篇、Java 基础篇（包括基础语法、面向对象、集合框架、异常处理、Java IO 等）、Java 并发篇和 Java 虚拟机篇。

## Java面渣逆袭

- [面渣逆袭（Java 基础篇）必看:+1:](docs/sidebar/sanfene/javase.md)
- [面渣逆袭（Java 集合框架篇）必看:+1:](docs/sidebar/sanfene/collection.md)
- [面渣逆袭（Java 并发编程篇）必看:+1:](docs/sidebar/sanfene/javathread.md)
- [面渣逆袭（Java 虚拟机篇）必看:+1:](docs/sidebar/sanfene/jvm.md)

## Java概述

- [什么是Java？Java发展简史，Java的优势](docs/overview/what-is-java.md)
- [第一个Java程序：Hello World](docs/overview/hello-world.md)


## Java基础语法

- [Java支持的8种基本数据类型](docs/basic-grammar/basic-data-type.md)
- [Java流程控制语句](docs/basic-grammar/flow-control.md)
- [Java运算符](docs/basic-grammar/operator.md)
- [Java注释：单行、多行和文档注释](docs/basic-grammar/javadoc.md)
- [Java中常用的48个关键字](docs/basic-extra-meal/48-keywords.md)
- [Java命名规范（非常全面，可以收藏）](docs/basic-extra-meal/java-naming.md)

## Java面向对象编程

- [怎么理解Java中类和对象的概念？](docs/oo/object-class.md)
- [Java变量的作用域：局部变量、成员变量、静态变量、常量](docs/oo/var.md)
- [Java方法](docs/oo/method.md)
- [Java构造方法](docs/oo/construct.md)
- [Java代码初始化块](docs/oo/code-init.md)
- [Java抽象类](docs/oo/abstract.md)
- [Java接口](docs/oo/interface.md)
- [Java中的static关键字解析](docs/oo/static.md)
- [Java中this和super的用法总结](docs/oo/this-super.md)
- [浅析Java中的final关键字](docs/oo/final.md)
- [Java instanceof关键字用法](docs/oo/instanceof.md)
- [深入理解Java中的不可变对象](docs/basic-extra-meal/immutable.md)
- [Java中可变参数的使用](docs/basic-extra-meal/varables.md)
- [深入理解Java泛型](docs/basic-extra-meal/generic.md)
- [深入理解Java注解](docs/basic-extra-meal/annotation.md)
- [Java枚举（enum）](docs/basic-extra-meal/enum.md)
- [大白话说Java反射：入门、使用、原理](docs/basic-extra-meal/fanshe.md)

## 字符串&数组

- [为什么String是不可变的？](docs/string/immutable.md)
- [深入了解Java字符串常量池](docs/string/constant-pool.md)
- [深入解析 String#intern](docs/string/intern.md)
- [Java判断两个字符串是否相等？](docs/string/equals.md)
- [Java字符串拼接的几种方式](docs/string/join.md)
- [如何在Java中优雅地分割String字符串？](docs/string/split.md)
- [深入理解Java数组](docs/array/array.md)
- [如何优雅地打印Java数组？](docs/array/print.md)

## 集合框架（容器）

- [Java集合框架](docs/collection/gailan.md)
- [Java集合ArrayList详解](docs/collection/arraylist.md)
- [Java集合LinkedList详解](docs/collection/linkedlist.md)
- [Java中ArrayList和LinkedList的区别](docs/collection/list-war-2.md)
- [Java中的Iterator和Iterable区别](docs/collection/iterator-iterable.md)
- [为什么阿里巴巴强制不要在foreach里执行删除操作](docs/collection/fail-fast.md)
- [Java8系列之重新认识HashMap](docs/collection/hashmap.md)

## Java输入输出

- [Java IO学习整理](docs/io/shangtou.md)
- [如何给女朋友解释什么是 BIO、NIO 和 AIO？](docs/io/BIONIOAIO.md)


## 异常处理

- [一文读懂Java异常处理](docs/exception/gailan.md)
- [详解Java7新增的try-with-resouces语法](docs/exception/try-with-resouces.md)
- [Java异常处理的20个最佳实践](docs/exception/shijian.md)
- [Java空指针NullPointerException的传说](docs/exception/npe.md)

## 常用工具类

- [Java Arrays工具类10大常用方法](docs/common-tool/arrays.md)
- [Java集合框架：Collections工具类](docs/common-tool/collections.md)
- [Hutool：国产良心工具包，让你的Java变得更甜](docs/common-tool/hutool.md)
- [Google开源的Guava工具库，太强大了～](docs/common-tool/guava.md)

## Java新特性

- [Java 8 Stream流详细用法](docs/java8/stream.md)
- [Java 8 Optional最佳指南](docs/java8/optional.md)
- [深入浅出Java 8 Lambda表达式](docs/java8/Lambda.md)

## Java重要知识点

- [彻底弄懂Java中的Unicode和UTF-8编码](docs/basic-extra-meal/java-unicode.md)
- [Java中int、Integer、new Integer之间的区别](docs/basic-extra-meal/int-cache.md)
- [深入剖析Java中的拆箱和装箱](docs/basic-extra-meal/box.md)
- [彻底讲明白的Java浅拷贝与深拷贝](docs/basic-extra-meal/deep-copy.md)
- [深入理解Java中的hashCode方法](docs/basic-extra-meal/hashcode.md)
- [一次性搞清楚equals和hashCode](docs/basic-extra-meal/equals-hashcode.md)
- [Java重写(Override)与重载(Overload)](docs/basic-extra-meal/override-overload.md)
- [Java重写（Overriding）时应当遵守的11条规则](docs/basic-extra-meal/Overriding.md)
- [Java到底是值传递还是引用传递？](docs/basic-extra-meal/pass-by-value.md)
- [Java不能实现真正泛型的原因是什么？](docs/basic-extra-meal/true-generic.md)
- [详解Java中Comparable和Comparator的区别](docs/basic-extra-meal/comparable-omparator.md)
- [jdk9为何要将String的底层实现由char[]改成了byte[]?](docs/basic-extra-meal/jdk9-char-byte-string.md)
- [为什么JDK源码中，无限循环大多使用for(;;)而不是while(true)?](docs/basic-extra-meal/jdk-while-for-wuxian-xunhuan.md)


## Java并发编程

- [室友打了一把王者就学会了创建Java线程的3种方式](docs/thread/wangzhe-thread.md)
- [Java线程的6种状态及切换(透彻讲解)](docs/thread/thread-state-and-method.md)
- [线程组是什么？线程优先级如何设置？](docs/thread/thread-group-and-thread-priority.md)
- [进程与线程的区别是什么？](docs/thread/why-need-thread.md)
- [并发编程带来了哪些问题？](docs/thread/thread-bring-some-problem.md)
- [全面理解Java的内存模型（JMM）](docs/thread/jmm.md)
- [Java并发编程volatile关键字解析](docs/thread/volatile.md)
- [Java中的synchronized关键字锁的到底是什么？](docs/thread/synchronized.md)
- [Java实现CAS的原理](docs/thread/cas.md)
- [Java并发AQS详解](docs/thread/aqs.md)
- [大致了解下Java的锁接口和锁](docs/thread/lock.md)
- [深入理解Java并发重入锁ReentrantLock](docs/thread/reentrantLock.md)
- [深入理解Java并发读写锁ReentrantReadWriteLock](docs/thread/ReentrantReadWriteLock.md)
- [深入理解Java并发线程协作类Condition](docs/thread/condition.md)
- [深入理解Java并发线程线程阻塞唤醒类LockSupport](docs/thread/LockSupport.md)
- [简单聊聊Java的并发集合容器](docs/thread/map.md)
- [吊打Java并发面试官之ConcurrentHashMap](docs/thread/ConcurrentHashMap.md)
- [吊打Java并发面试官之ConcurrentLinkedQueue](docs/thread/ConcurrentLinkedQueue.md)
- [吊打Java并发面试官之CopyOnWriteArrayList](docs/thread/CopyOnWriteArrayList.md)
- [吊打Java并发面试官之ThreadLocal](docs/thread/ThreadLocal.md)
- [吊打Java并发面试官之BlockingQueue](docs/thread/BlockingQueue.md)
- [面试必备：Java线程池解析](docs/thread/pool.md)
- [为什么阿里巴巴要禁用Executors创建线程池？](docs/thread/ali-executors.md)
- [深入剖析Java计划任务ScheduledThreadPoolExecutor](docs/thread/ScheduledThreadPoolExecutor.md)
- [Java atomic包中的原子操作类总结](docs/thread/atomic.md)
- [Java并发编程通信工具类CountDownLatch等一网打尽](docs/thread/CountDownLatch.md)
- [深入理解Java并发编程之Fork/Join框架](docs/thread/fork-join.md)
- [从根上理解生产者-消费者模式](docs/thread/shengchanzhe-xiaofeizhe.md)


## Java虚拟机

- [JVM到底是什么？](docs/jvm/what-is-jvm.md)
- [JVM到底是如何运行Java代码的？](docs/jvm/how-run-java-code.md)
- [我竟然不再抗拒Java的类加载机制了](docs/jvm/class-load.md)
- [详解Java的类文件（class文件）结构](docs/jvm/class-file-jiegou.md)
- [从javap的角度轻松看懂字节码](docs/jvm/bytecode.md)
- [JVM字节码指令详解](docs/jvm/zijiema-zhiling.md)
- [虚拟机是如何执行字节码指令的？](docs/jvm/how-jvm-run-zijiema-zhiling.md)
- [HSDB（Hotspot Debugger）从入门到实战](docs/jvm/hsdb.md)
- [史上最通俗易懂的ASM教程](docs/jvm/asm.md)
- [自己编译JDK](docs/jvm/compile-jdk.md)
- [深入理解JVM的内存结构](docs/jvm/neicun-jiegou.md)
- [Java 创建的对象到底放在哪？](docs/jvm/whereis-the-object.md)
- [咱们从头到尾说一次Java垃圾回收](docs/jvm/gc.md)
- [图解Java的垃圾回收机制](docs/jvm/tujie-gc.md)
- [Java问题诊断和排查工具（查看JVM参数、内存使用情况及分析）](docs/jvm/problem-tools.md)
- [Java即时编译（JIT）器原理解析及实践](docs/jvm/jit.md)
- [一次内存溢出排查优化实战](docs/jvm/oom.md)
- [一次生产CPU 100% 排查优化实践](docs/jvm/cpu-percent-100.md)
- [JVM 核心知识点总结](docs/jvm/zongjie.md)


# Java企业级开发

> [!NOTE]
>  - **到底能不能成为一名合格的 Java 程序员，从理论走向实战？Java 企业级开发这部分内容就是一个分水岭**！
>  - 纸上得来终觉浅，须知此事要躬行。

## 开发工具

- [终于把项目构建神器Maven捋清楚了~](docs/maven/maven.md)
- [我在工作中是如何使用Git的](docs/git/git-qiyuan.md)
- [5分钟带你深入浅出搞懂Nginx](docs/nginx/nginx.md)

## IDE/编辑器

- [4个高级的IntelliJ IDEA调试技巧](docs/ide/4-debug-skill.md)

## Spring

- [Spring AOP扫盲](docs/springboot/aop-log.md)
- [Spring IoC扫盲](docs/springboot/ioc.md)


## SpringBoot

- [一分钟快速搭建Spring Boot项目](docs/springboot/initializr.md)
- [Spring Boot为什么不需要额外安装Tomcat？](docs/springboot/tomcat.md)


## 辅助工具/轮子

- [Tabby：一款逼格更高的开源终端工具](docs/gongju/tabby.md)
- [chiner：一款开源的数据库设计神器](docs/gongju/chiner.md)
- [DBeaver：一款免费的数据库操作工具](docs/gongju/DBeaver.md)
- [knife4j：一款界面更炫酷的API文档生成神器](docs/gongju/knife4j.md)
- [MyBatis-Plus AutoGenerator：一款开发效率更高的代码生成工具](docs/kaiyuan/auto-generator.md)
- [Junit：一个开源的Java单元测试框架](docs/gongju/junit.md)
- [fastjson：阿里巴巴开源的JSON解析库](docs/gongju/fastjson.md)
- [Gson：Google开源的JSON解析库](docs/gongju/gson.md)
- [Jackson：GitHub上star数最多的JSON解析库](docs/gongju/jackson.md)
- [Forest：一款极简的声明式HTTP调用API框架](docs/gongju/forest.md)
- [Log4j：Log4j 2的前身，Java日志框架的鼻祖](docs/gongju/log4j.md)
- [Log4j 2：Apache维护的一款高性能日志记录工具](docs/gongju/log4j2.md)
- [Logback：Spring Boot内置的日志处理框架](docs/gongju/logback.md)
- [SLF4J：阿里巴巴强制使用的日志门面担当](docs/gongju/slf4j.md)
- [其他辅助工具/轮子](docs/gongju/others.md)


## 安全篇

## 分布式

- [全文搜索引擎Elasticsearch入门教程](docs/elasticsearch/rumen.md)
- [可能是把ZooKeeper概念讲的最清楚的一篇文章](docs/zookeeper/jibenjieshao.md)

## 高性能

### 消息队列

- [RabbitMQ入门教程（概念、应用场景、安装、使用）](docs/mq/rabbitmq-rumen.md)

## 高可用

# 数据库

> [!NOTE]
>  - **简而言之，就是按照数据结构来组织、存储和管理数据的仓库**。几乎所有的 Java 后端开发都要学习数据库这块的知识，包括关系型数据库 MySQL，缓存中间件 Redis，非关系型数据库 MongoDB 等。

## MySQL

## Redis

- [Redis入门(适合新手)](docs/redis/rumen.md)
- [简单聊聊缓存雪崩、穿透、击穿](docs/redis/xuebeng-chuantou-jichuan.md)


## MongoDB

- [MongoDB最基础入门教程](docs/mongodb/rumen.md)


# 计算机基础

> [!NOTE]
>  - **计算机基础包括操作系统、计算机网络、计算机组成原理、数据结构与算法等**。对于任何一名想要走得更远的 Java 后端开发来说，都是必须要花时间和精力去夯实的。
>  - 万丈高露平地起，勿在浮沙筑高台。

- [计算机操作系统知识点大梳理](docs/cs/os.md)
- [计算机网络核心知识点大梳理](docs/cs/wangluo.md)


# 求职面试

> [!NOTE]
>  - **学习了那么多 Java 知识，耗费了无数的脑细胞，熬掉了无数根秀发，为的是什么？当然是谋取一份心仪的 offer 了**。那八股文、面试题、城市选择、优质面经又怎能少得了呢？
>  - 千淘万漉虽辛苦，吹尽狂沙始到金。

## 面试题集合

- [Java：34道精选高频面试题](docs/baguwen/java-basic-34.md)
- [Java：HashMap精选面试题](docs/collection/hashmap-interview.md)
- [Redis：12道精选高频面试题）](docs/mianjing/redis12question.md)
- [MQ：怎么确保消息100%不丢失？](docs/mq/100-budiushi.md)


## 背诵版八股文

- [Java 基础八股文（背诵版）必看:+1:](docs/baguwen/java-basic.md)
- [Java 并发编程八股文（背诵版）必看:+1:](docs/baguwen/java-thread.md)
- [Java 虚拟机八股文（背诵版）必看:+1:](docs/baguwen/jvm.md)
- [MySQL 八股文（背诵版）必看:+1:](docs/sidebar/herongwei/mysql.md)


## 优质面经

- [春招斩获深圳腾讯PCG和杭州阿里云](docs/mianjing/shanganaliyun.md)
- [社招拿下阿里美团头条京东滴滴)](https://mp.weixin.qq.com/s/h2tV6v5Rh6jHdO9x0p63-g)
- [字节小姐姐的一份秋招攻略](https://mp.weixin.qq.com/s/0hCJy0m8nHm08HfyXKQT1A)
- [面试常见词汇扫盲+常见大厂面试特点分享](https://mp.weixin.qq.com/s/6TYEDM73N68vKXpmLRKhHA)
- [双非学历的社畜，历经 6 轮面试，最终拿下阿里Offer](https://mp.weixin.qq.com/s/vnMZY9Gsy3o1FwMi4f1GlA)

## 面试准备

- [简历如何优化，简历如何投递，面试如何准备？](https://mp.weixin.qq.com/s/qurUqeD_VyiJRtB38vOuSw)
- [校招时间节点、简历编写、笔试、、HR面、实习等注意事项](https://mp.weixin.qq.com/s/rO7cU4NX74CoWADo_O4IUw)

## 城市选择

- [北京都有哪些牛逼的互联网公司？](docs/cityselect/beijing.md)
- [想去广州了！](docs/cityselect/guangzhou.md)
- [深圳有哪些牛批的互联网公司？](docs/cityselect/shenzhen.md)
- [西安有哪些不错的互联网公司？](docs/cityselect/xian.md)
- [青岛有牛逼的互联网公司吗？](docs/cityselect/qingdao.md)
- [郑州有哪些不错的互联网公司？](docs/cityselect/zhengzhou.md)
- [想搬去苏州生活了。。](docs/cityselect/suzhou.md)
- [南京有哪些靠谱的互联网公司？](docs/cityselect/nanjing.md)
- [杭州有哪些顶级的互联网公司？](docs/cityselect/hangzhou.md)
- [成都有哪些牛批的互联网公司？](docs/cityselect/chengdu.md)

## 工作体会



# 学习资源

> [!NOTE]
>  - **不知道学什么？不知道该怎么学？找不到优质的学习资源**？这些问题在这里统统都可以找到答案。
>  - 我会把自己十多年的编程经验和学习资源毫不保留的分享出来。

## PDF下载

- [👏下载→Java程序员常读书单](docs/download/java.md)
- [👏下载→最全最硬核的Java面试 “备战” 资料](https://mp.weixin.qq.com/s/US5nTxbC2nYc1hWpn5Bozw)
- [👏下载→深入浅出Java多线程](https://mp.weixin.qq.com/s/pxKrjw_5NTdZfHOKCkwn8w)
- [👏下载→GitHub星标115k+的Java教程](https://mp.weixin.qq.com/s/d7Z0QoChNuP9bTwAGh2QCw)
- [👏下载→重学Java设计模式](https://mp.weixin.qq.com/s/PH5AizUAnTz0CuvJclpAKw)
- [👏下载→Java版LeetCode刷题笔记](https://mp.weixin.qq.com/s/FyoOPIMGcaeH0z5RMhxtaQ)
- [👏下载→阮一峰C语言入门教程](docs/download/yuanyifeng-c-language.md)
- [👏下载→BAT大佬的刷题笔记](docs/download/bat-shuati.md)
- [👏下载→给操作系统捋条线](https://mp.weixin.qq.com/s/puTGbgU7xQnRcvz5hxGBHA)
- [👏下载→豆瓣9.1分，Pro Git中文版](docs/download/progit.md)
- [👏下载→简历模板](docs/download/jianli.md)

### 学习建议

- [如何阅读《深入理解计算机系统》这本书？](docs/xuexijianyi/read-csapp.md)
- [电子信息工程最好的出路的是什么？](docs/xuexijianyi/electron-information-engineering.md)


# 知识库搭建历程

> [!NOTE]
> 从购买阿里云服务器+域名购买+域名备案+HTTP 升级到 HTTPS，全方面记录《Java 程序员进阶之路》知识库的诞生和改进过程，涉及到 docsify、Git、Linux 命令、GitHub 仓库等实用知识点。

- [阿里云服务器购买+宝塔面板安装+域名购买+域名备案+升级HTTPS](docs/szjy/tobebetterjavaer-beian.md)
- [使用docsify+Git+GitHub+码云+阿里云服务器搭建知识库网站](docs/szjy/tobebetterjavaer-wangzhan-shangxian.md)


# 联系作者

> [!NOTE]
>- 作者是一名普通普通普通普通三连的 Java 后端开发者，热爱学习，热爱分享
>- 参加工作以后越来越理解交流和分享的重要性，在不停地汲取营养的同时，也希望帮助到更多的小伙伴们
>- Java 程序员进阶之路，不仅是作者自学 Java 以来所有的原创文章和学习资料的大聚合，更是作者向这个世界传播知识的一个窗口。

## 心路历程

- [走近作者：个人介绍 Q&A](docs/about-the-author/readme.md)
- [我的第一个，10 万(B站视频播放)](docs/about-the-author/bzhan-10wan.md)
- [我的第一个，一千万！知乎阅读](docs/about-the-author/zhihu-1000wan.md)
- [我的第二个，一千万！CSDN阅读](docs/about-the-author/csdn-1000wan.md)

## 联系方式

### 技术交流群

本群的宗旨是给大家提供一个良好的技术学习交流平台，所以杜绝一切广告！<br>由于微信群人满 100 之后无法加入，请先添加作者微信「qing_geee」（也可以扫描下方的二维码），备注：加群。

<div align="left">
    <img src="http://cdn.tobebetterjavaer.com/tobebetterjavaer/images/qing_geee.png" width="260px">
</div>

### 原创公众号

本号的slogan：技术文通俗易懂，吹水文风趣幽默。<br>目前已有 10 万+读者关注，微信搜索「**沉默王二**」（也可以扫描下方的二维码）就可以关注作者了。

<div align="left">
    <img src="http://cdn.tobebetterjavaer.com/tobebetterjavaer/images/gongzhonghao.png" width="260px">
</div>

关注后，回复关键字「**00**」可以获取更多优质的 Java 学习资料。
    
    
### star趋势图

[![Stargazers over time](https://starchart.cc/itwanger/toBeBetterJavaer.svg)](https://starchart.cc/itwanger/toBeBetterJavaer)


### 友情链接

- [Hippo4J](https://github.com/acmenlt/dynamic-threadpool)，🔥 强大的动态线程池，附带监控报警功能（没有依赖中间件），完全遵循阿里巴巴编码规范。
- [JavaGuide](https://github.com/Snailclimb/JavaGuide)，「Java学习+面试指南」一份涵盖大部分 Java 程序员所需要掌握的核心知识。准备 Java 面试，首选 JavaGuide！

### 捐赠鼓励

开源不易，如果《Java 程序员进阶之路》对你有些帮助，可以请作者喝杯咖啡，算是对开源做出的一点点鼓励吧！

<div align="left">
    <img src="http://cdn.tobebetterjavaer.com/tobebetterjavaer/images/weixin-zhifu.png" width="260px">
</div>

:gift_heart: 感谢大家对我资金的赞赏，每隔一个月会统计一次。

时间|小伙伴|赞赏金额
---|---|---
2022-03-04|袁*波|99元
2022-02-17|*色|1元
2022-02-17|M*y|1元
2022-01-28|G*R|6.6元
2022-01-20|*光|50元
2022-01-14|*浩|1元
2022-01-01|马*谊|6.6元
2022-01-01|刚*好|3.6元
2021-12-20|t*1|5 元
2021-10-26|*鱼|28 元
2021-10-11|*人|28 元
2021-09-01|S*n|6.6 元
2021-08-02|*秒|1 元
2021-06-13|*7| 28 元
2021-04-29|p*e|2 元



### 参与贡献

1. 如果你对本项目有任何建议或发现文中内容有误的，欢迎提交 issues 进行指正。
2. 对于文中我没有涉及到知识点，欢迎提交 PR。



